/* Fake loader.  It just copies the file, for now */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "io.h"
#include "symbol.h"
#include "loader.h"
#include "dislib.h"
#include "version.h"

static void usage(char *exec_name,int show_help) {
   
   fprintf(stderr,"\n%s version %s\n\n",exec_name,VERSION);
   
   if (show_help) {
      fprintf(stderr, "\tUsage: %s <object-file> "
	      "-o <executable-file> \n\n", exec_name);
      fprintf(stderr, "\n");
   }
   exit(1);   
}

int main(int argc, char **argv) {

   FILE *object;
   FILE *exe;

   char *object_filename=NULL,*exe_filename=NULL;
   
   int i;
   
   
   /************************************************/
   /* Parse Command Line Arguments                 */
   /************************************************/
   for(i=0;i<argc;i++) {   

      if (argv[i][0]=='-') {
	    /* help */
	 if (argv[i][1]=='h') {
	    usage(argv[0],1);
	 }
	    /* version */
	 if (argv[i][1]=='v') {
	    usage(argv[0],0);
	 }

	    /* output filename */
	 if (argv[i][1]=='o') {
	    if ((i+1)<argc) {
	       exe_filename = strdup(argv[i+1]);
	       i++;
	    }
	 }
      }
      else {
         object_filename = strdup(argv[i]);
      }
   }
   
   if ((object_filename==NULL) || (exe_filename==NULL)) {
      usage(argv[0],1);
   }


   /* open files */

   object = fopen(object_filename, "r");
   if (object == NULL) {
      fprintf(stderr, "ERROR opening object file: %s\n", object_filename);
      exit(1);
   }
   
   exe = fopen(exe_filename, "w");
   if (exe == NULL) {
      fprintf(stderr, "ERROR opening exec file: %s\n", 
	      exe_filename);
      exit(1);
   }

   while(1) {
    
      i=fgetc(object);
      if (i<0) break;
      fputc(i,exe);
   }
   
   fclose(object);   
   fclose(exe);
   
   return 0;
}

