#define VMW_TEXT   0
#define VMW_DATA   1
#define VMW_BSS    2
#define VMW_SYMBOL 3

#define SYMBOL_TEXT 1
#define SYMBOL_DATA 2
#define SYMBOL_BSS  4
#define SYMBOL_EQU  8
#define SYMBOL_ANY  255

#define OBJECT_OLD 0
#define OBJECT_NEW 1

#define MAX_SECTIONS 5

struct section_type {
  int type;
  int size;
  int offset;  
};

struct object_type {
  FILE *file;
  int type;
  int sections;
  struct section_type section[MAX_SECTIONS];
  int bss_size,bss_offset;
  int text_size,text_offset;
  int header_size;
};

extern struct object_type object;

int open_object(char *filename);
int read_short(short *our_short);
int close_object();
int write_header(FILE *object_file,
		 int symbol_size,int symbol_offset,
		 int text_size,int text_offset,
		 int bss_size,int bss_offset);
